/***
*
*	Copyright (C) 2002 The Wastes Project, All Rights Reserved.
*	
*	This product contains software technology from Valve Software, LLC,
*	Copyright  1996-2001, Valve LLC, All rights reserved.
*
*   Use, distribution, and modification of this source code and/or resulting
*   object code is restricted to non-commercial enhancements to products from
*   The Wastes Project.  All other use, distribution, or modification is prohibited
*   without written permission from The Wastes Project.
*
***/
#if !defined( __PARSEBSPENT_H_ )
#define __PARSEBSPENT_H_

class CBspEntity
{
public:
	CBspEntity();

	virtual void AddEntity() = 0;
	virtual void ResetVars();
	virtual void SetKeyValue( const char *pszKey, const char *pszValue );

	char  szClassname[32];
	float flOrigin[3];
};

class CBspWorldspawn : public CBspEntity
{
public:
	void AddEntity();
	void ResetVars();
	void SetKeyValue( const char *pszKey, const char *pszValue );

	// Fog info
	int iEnableFog;

	float flFogcolor_r;
	float flFogcolor_g;
	float flFogcolor_b;
	float flFogcolor_start;
	float flFogcolor_end;
};

class CBspEnvFog : public CBspEntity
{
public:
	void AddEntity();
	void ResetVars();
	void SetKeyValue( const char *pszKey, const char *pszValue );

	int iRadius;
	int iFogState;
	float flFogcolor_r;
	float flFogcolor_g;
	float flFogcolor_b;
	float flFog_start;
	float flFog_end;
};

class CBspEnvParticleSystem : public CBspEntity
{
public:
	void AddEntity();
	void ResetVars();
	void SetKeyValue( const char *pszKey, const char *pszValue );

	int iClientSide;
	char szParticleSystem[64];
};

extern CBspWorldspawn g_Worldspawn;

#endif