/***
*
*	Copyright (c) 1996-2001, Valve LLC. All rights reserved.
*	
*	This product contains software technology licensed from Id 
*	Software, Inc. ("Id Technology").  Id Technology (c) 1996 Id Software, Inc. 
*	All Rights Reserved.
*
*   Use, distribution, and modification of this source code and/or resulting
*   object code is restricted to non-commercial enhancements to products from
*   Valve LLC.  All other use, distribution, or modification is prohibited
*   without written permission from Valve LLC.
*
****/
#include "extdll.h"
#include "eiface.h"
#include "util.h"
#include "game.h"

cvar_t	displaysoundlist = {"displaysoundlist","0"};

// multiplayer server rules
cvar_t	fragsleft	     = {"mp_fragsleft","0", FCVAR_SERVER | FCVAR_UNLOGGED };		// Don't spam console/log files/users with this changing
cvar_t	timeleft         = {"mp_timeleft","0" , FCVAR_SERVER | FCVAR_UNLOGGED };	    // "      "

// multiplayer server rules
cvar_t  gametype    = {"mp_gametype","0", FCVAR_SERVER };
cvar_t	fraglimit	= {"mp_fraglimit","0", FCVAR_SERVER };
cvar_t  roundtimelimit = {"mp_roundtimelimit","3",FCVAR_SERVER };
cvar_t	timelimit	= {"mp_timelimit","0", FCVAR_SERVER };
cvar_t	friendlyfire= {"mp_friendlyfire","0", FCVAR_SERVER };
cvar_t	weaponstay	= {"mp_weaponstay","0", FCVAR_SERVER };
cvar_t	flashlight	= {"mp_flashlight","0", FCVAR_SERVER };
cvar_t	decalfrequency = {"decalfrequency","30", FCVAR_SERVER };
cvar_t	teamlist = {"mp_teamlist","hgrunt;scientist", FCVAR_SERVER };
cvar_t	teamoverride = {"mp_teamoverride","1" };
cvar_t	defaultteam = {"mp_defaultteam","0" };
cvar_t	allowmonsters={"mp_allowmonsters","0", FCVAR_SERVER };
cvar_t  maxlives={"mp_maxlives","1",FCVAR_SERVER };

cvar_t  allowsidearms   = {"mp_allowsidearms","1",FCVAR_SERVER|FCVAR_UNLOGGED};
cvar_t  allowsecondary  = {"mp_allowprimary","1",FCVAR_SERVER|FCVAR_UNLOGGED};
cvar_t  allowunique     = {"mp_allowunique","1",FCVAR_SERVER|FCVAR_UNLOGGED};
cvar_t  allowexplosives = {"mp_allowexplosives","1",FCVAR_SERVER|FCVAR_UNLOGGED};

cvar_t  mp_chattime = {"mp_chattime","10", FCVAR_SERVER };

// Engine Cvars
cvar_t 	*g_psv_gravity = NULL;
cvar_t	*g_psv_aim = NULL;

// END Cvars for Skill Level settings

// Register your console variables here
// This gets called one time when the game is initialied
void GameDLLInit( void )
{
	// Register cvars here:
	g_psv_gravity = CVAR_GET_POINTER( "sv_gravity" );
	g_psv_aim = CVAR_GET_POINTER( "sv_aim" );

	CVAR_REGISTER (&displaysoundlist);

	CVAR_REGISTER (&gametype);
	CVAR_REGISTER (&fraglimit);
	CVAR_REGISTER (&roundtimelimit);
	CVAR_REGISTER (&timelimit);

	CVAR_REGISTER (&fragsleft);
	CVAR_REGISTER (&timeleft);

	CVAR_REGISTER (&friendlyfire);
	CVAR_REGISTER (&weaponstay);
	CVAR_REGISTER (&flashlight);
	CVAR_REGISTER (&decalfrequency);
	CVAR_REGISTER (&teamlist);
	CVAR_REGISTER (&teamoverride);
	CVAR_REGISTER (&defaultteam);
	CVAR_REGISTER (&allowmonsters);
	CVAR_REGISTER (&maxlives);

	CVAR_REGISTER (&allowsidearms);
	CVAR_REGISTER (&allowsecondary);
	CVAR_REGISTER (&allowunique);
	CVAR_REGISTER (&allowexplosives);

	CVAR_REGISTER (&mp_chattime);

// END REGISTER CVARS FOR SKILL LEVEL STUFF

	SERVER_COMMAND( "exec skill.cfg\n" );
}

