/***
*
*	WastedFX Tool chain
*
*	Author: Joshua Coyne
*	Copyright (C) 2003 The Wastes Project, All Rights Reserved.
*
***/
#include "WastedFX.h"
#include "Camera.h"

#define CLAMP_VALUE( variable, lower, upper ) \
			if( variable > upper ) \
				variable = upper; \
			else if( variable < lower ) \
				variable = lower;

float g_flSpeed = 0.1f;
float g_flMouseSpeed = 1000.0f;

CCamera::CCamera()
{
	memset( &m_LastPos, 0, sizeof( POINT ) );
	m_iMouseMode = MOUSE_NONE;
}

CCamera::CCamera( psvec3_t Origin, psvec3_t Angles )
{
	CCamera();

	memcpy( m_Origin, Origin, sizeof( psvec3_t ) );
	memcpy( m_Angles, Angles, sizeof( psvec3_t ) );
}

// Read mouse input
void CCamera::ReadInput( float flFrametime )
{
	POINT mousePos;

	GetCursorPos( &mousePos );

	// We havent moved
	if( m_LastPos.x == mousePos.x && m_LastPos.y == mousePos.y )
		return;

	switch( m_iMouseMode )
	{
	case MOUSE_NONE:
		memcpy( &m_LastPos, &mousePos, sizeof( POINT ) );
		return;
	case MOUSE_LEFT:
		// Zoom
/*		{
			float MoveDist = m_LastPos.y - mousePos.y;

			// Move left to right
			m_Angles[1] += -(m_LastPos.x - mousePos.x) * 0.25f;

			m_Origin[0] += (float)sin( m_Angles[1]*M_PI/180.0f ) * MoveDist;
			m_Origin[2] += (float)cos( m_Angles[1]*M_PI/180.0f ) * MoveDist;
		}*/
/*		{
			float AnglePitch, AngleYaw;
			psvec3_t forward;

			m_Angles[1] -= m_LastPos.x - mousePos.x;

			// Get forward vector
			AnglePitch = m_Angles[1] * ( M_PI*2 / 360.0f );
			AngleYaw = m_Angles[0] * ( M_PI*2 / 360.0f );

			forward[1] = cos( AnglePitch ) * cos( AngleYaw );
			forward[0] = cos( AnglePitch ) * sin( AngleYaw );
			forward[2] = -(sin( AnglePitch ));
			
			// Move along forward vector
			VectorMA( forward, (m_LastPos.y - mousePos.y) * 0.25f, m_Origin, forward );
			VectorAdd( m_Origin, forward, m_Origin );
		}*/
		break;
	case MOUSE_RIGHT:
		// Rotate
		m_Angles[1] += -(m_LastPos.x - mousePos.x) * 0.25f;
		m_Angles[0] += -(m_LastPos.y - mousePos.y) * 0.25f;
		break;
	case MOUSE_BOTH:
		// Move
/*		{
			float MoveX = m_LastPos.x - mousePos.x;
			float MoveY = m_LastPos.y - mousePos.y;

			m_
			m_Origin[1] += -MoveY;
		}*/
//		m_Origin[0] += m_LastPos.x - mousePos.x;
//		m_Origin[1] += -(m_LastPos.y - mousePos.y);
/*		{
			psvec3_t forward,right,up;
			float forwardscale,sidescale;

			AngleVectors( m_Angles, forward, right, up );

			forwardscale = m_LastPos.x - mousePos.x;
			sidescale = m_LastPos.y - mousePos.y;

			VectorMA( m_Origin, forwardscale, forward, m_Origin );
			VectorMA( m_Origin, sidescale, right, m_Origin );
		}*/
		break;
	}

	// Clamp values
	CLAMP_VALUE( m_Angles[0], -90, 90 );

	if( m_Angles[1] < 0.0f )
		m_Angles[1] += 360.0f;
	else if( m_Angles[1] > 360.0f )
		m_Angles[1] -= 360.0f;

	if( m_Angles[2] < 0.0f )
		m_Angles[2] += 360.0f;
	else if( m_Angles[2] > 360.0f )
		m_Angles[2] -= 360.0f;

	SetCursorPos( m_LastPos.x, m_LastPos.y );
}

// Reset mouse input vars
void CCamera::ResetInput()
{
	POINT mousePos;

	m_iMouseMode = MOUSE_NONE;
	GetCursorPos( &mousePos );
	memcpy( &m_LastPos, &mousePos, sizeof( POINT ) );
}
