/***
*
*	WastedFX Tool chain
*
*	Author: Joshua Coyne
*	Copyright (C) 2003 The Wastes Project, All Rights Reserved.
*
***/
#include "WastedFX.h"
#include "Window.h"
#include "MainWindow.h"
#include "GLWindow.h"
#include <list>
using namespace std;

/*
=========================
 WinMain

 Program entry point
=========================
*/
INT WINAPI WinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance, 
				    PSTR szCmdLine, int iCmdShow )
{
	MSG msg;
	int iQuit = 0;
	list<CWindow*> WindowList;

	WindowList.push_back( new CMainWindow( WINCLASS_MAIN, hInstance ) );
	WindowList.push_back( new CGLWindow( WINCLASS_GL, hInstance ) );
	
	// Message pump
	while( !iQuit )
	{
		if( PeekMessage( &msg, NULL, 0, 0, PM_REMOVE ) )
		{
			if( msg.message == WM_QUIT )
				iQuit = 1;

			TranslateMessage( &msg );
			DispatchMessage( &msg );
		}
		else
		{
			// Update windows
			if( WindowList.size() )
			{
				list<CWindow*>::iterator iter;

				for( iter = WindowList.begin(); iter != WindowList.end(); iter++ )
					(*iter)->Update();
			}
		}
	}

	// Clean up
	if( WindowList.size() )
	{
		list<CWindow*>::iterator iter;

		for( iter = WindowList.begin(); iter != WindowList.end(); iter++ )
			delete (*iter);
	}

	return msg.wParam;
}