/***
*
*	WastedFX Tool chain
*
*	Author: Joshua Coyne
*	Copyright (C) 2003 The Wastes Project, All Rights Reserved.
*
***/
#include "WastedFX.h"
#include "Window.h"
#include "MainWindow.h"

#define WINDOW_TITLE PROGRAM_NAME

/*
=========================
 MainWndProc

 Main window procedure
=========================
*/
LRESULT CALLBACK MainWndProc( HWND hWnd, UINT iMsg, WPARAM wParam, LPARAM lParam )
{
	switch( iMsg )
	{
	case WM_COMMAND:
		switch( LOWORD( wParam ) )
		{
		case ID_FILE_NEW1:
			GetClassFromUserData<CMainWindow>( hWnd )->OnFileNew();
			return 0;
		case ID_FILE_OPEN1:
			GetClassFromUserData<CMainWindow>( hWnd )->OnFileOpen();
			return 0;
		case ID_FILE_SAVE1:
			GetClassFromUserData<CMainWindow>( hWnd )->OnFileSave();
			return 0;
		case ID_FILE_SAVEAS:
			GetClassFromUserData<CMainWindow>( hWnd )->OnFileSaveas();
			return 0;
		case ID_FILE_QUIT:
			GetClassFromUserData<CMainWindow>( hWnd )->OnFileQuit();
			return 0;
		case ID_EDIT_CUT1:
			GetClassFromUserData<CMainWindow>( hWnd )->OnEditCut();
			return 0;
		case ID_EDIT_COPY1:
			GetClassFromUserData<CMainWindow>( hWnd )->OnEditCopy();
			return 0;
		case ID_EDIT_PASTE1:
			GetClassFromUserData<CMainWindow>( hWnd )->OnEditPaste();
			return 0;
		case ID_EDIT_OPTIONS:
			GetClassFromUserData<CMainWindow>( hWnd )->OnEditOptions();
			return 0;
		case ID_PREVIEW_EMITTERPREVIEW:
			GetClassFromUserData<CMainWindow>( hWnd )->OnPreviewEmitter();
			return 0;
		case ID_PREVIEW_MAPPREVIEW:
			GetClassFromUserData<CMainWindow>( hWnd )->OnPreviewMap();
			return 0;
		case ID_PREVIEW_MODELPREVIEW:
			GetClassFromUserData<CMainWindow>( hWnd )->OnPreviewModel();
			return 0;
		case ID_HELP_ONLINEHELP:
			GetClassFromUserData<CMainWindow>( hWnd )->OnHelpOnlineHelp();
			return 0;
		case ID_HELP_ABOUT:
			GetClassFromUserData<CMainWindow>( hWnd )->OnHelpAbout();
			return 0;
		}
		break;
	case WM_CLOSE:
	case WM_DESTROY:
		// Todo: tie into member func ?
		PostQuitMessage( 0 );
		return 0;
	}

	return DefWindowProc( hWnd, iMsg, wParam, lParam );
}

CMainWindow::CMainWindow( char *pszClassname, HINSTANCE hInstance ) : CWindow( pszClassname, hInstance )
{
	if( RegisterWindow( CS_HREDRAW|CS_VREDRAW,
		                MainWndProc,
						(HICON)LoadImage( m_hInstance, MAKEINTRESOURCE( IDI_ICON1 ), IMAGE_ICON, 0, 0, LR_DEFAULTSIZE ), 
						(HICON)LoadImage( m_hInstance, MAKEINTRESOURCE( IDI_ICON1 ), IMAGE_ICON, 0, 0, LR_DEFAULTSIZE ),
						LoadCursor( NULL, IDC_ARROW ),
						(HBRUSH)GetStockObject( GRAY_BRUSH ),
						LoadMenu( m_hInstance, MAKEINTRESOURCE( IDR_MENUMAIN ) ) ) )
	{
		InstanceWindow( PROGRAM_NAME, WS_OVERLAPPEDWINDOW|WS_CLIPCHILDREN|WS_CLIPSIBLINGS,
					    NULL, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT );

		SetWindowLong( m_hWnd, GWL_USERDATA, (LONG)this );

		ShowWindow( m_hWnd, SW_NORMAL );
		UpdateWindow( m_hWnd );
	}
}

CMainWindow::~CMainWindow()
{
}

void CMainWindow::Update()
{
}

void CMainWindow::OnFileNew()
{
}

void CMainWindow::OnFileOpen()
{
}

void CMainWindow::OnFileSave()
{
}

void CMainWindow::OnFileSaveas()
{
}

void CMainWindow::OnFileQuit()
{
	// TODO: Save changes ?
	PostQuitMessage( 0 );
}

void CMainWindow::OnEditCut()
{
}

void CMainWindow::OnEditCopy()
{
}

void CMainWindow::OnEditPaste()
{
}

void CMainWindow::OnEditOptions()
{
}

void CMainWindow::OnPreviewEmitter()
{
}

void CMainWindow::OnPreviewMap()
{
}

void CMainWindow::OnPreviewModel()
{
}

void CMainWindow::OnHelpOnlineHelp()
{
	CWindow::Error( this, "Online Help", "There is no online help available at this time", ERR_INFO );
}

void CMainWindow::OnHelpAbout()
{
}