/***
*
*	WastedFX Tool chain
*
*	Author: Joshua Coyne
*	Copyright (C) 2003 The Wastes Project, All Rights Reserved.
*
***/
#include "WastedFX.h"
#include "Timer.h"

CTimer::CTimer() : m_LastTime( 0.0f )
{
	if( QueryPerformanceFrequency( &m_PerfFrequency ) )
		m_UsePerfCounter = TRUE;
	else
		m_UsePerfCounter = FALSE;
}

void CTimer::StartTimer()
{
	if( m_UsePerfCounter )
	{
		QueryPerformanceCounter( &m_PerfStartCount );
	}
/*	else
	{
	}*/
}

void CTimer::EndTimer()
{
	if( m_UsePerfCounter )
	{
		QueryPerformanceCounter( &m_PerfEndCount );

		m_Time = ((float)m_PerfEndCount.QuadPart - (float)m_PerfStartCount.QuadPart) / m_PerfFrequency.QuadPart;
	}
	else
	{
		float CurrentTime = GetTickCount() * 0.001f;
		
		m_Time = CurrentTime - m_LastTime;
		m_LastTime = CurrentTime;
	}
}