/***
*
*	Copyright (C) 2002 The Wastes Project, All Rights Reserved.
*	
*	This product contains software technology from Valve Software, LLC,
*	Copyright  1996-2001, Valve LLC, All rights reserved.
*
*   Use, distribution, and modification of this source code and/or resulting
*   object code is restricted to non-commercial enhancements to products from
*   The Wastes Project.  All other use, distribution, or modification is prohibited
*   without written permission from The Wastes Project.
*
***/
#ifndef __STUDIOTWM_H_
#define __STUDIOTWM_H_

#define MAX_STRLEN 1024

typedef struct smdvertex_s
{
	twm_vert_t origin;
	float u,v;
} smdvertex_t;

typedef struct smdtriangle_s
{
	char texturename[64];
	smdvertex_t verts[3];
} smdtriangle_t;

typedef struct smdref_s
{
	// Triangles
	int num_triangles;
	smdtriangle_t *triangles;
} smdref_t;

//
// buildtwm.c
//
int TWM_BuildFromSMD(char *filename,smdref_t *smdref);

//
// parsesmd.c
//
void SMD_ConvertToTWM(char *filein,char *fileout);
int SMD_Error(int errid,char *pszStream,...);

//
// studiotwm.c
//
extern char g_szTexturePath[MAX_STRLEN];
extern float g_flScale;

#endif